
#include <esplib.h>
#include <ewclib.h> 
#include <math.h> 

int pt[28][2]={
97, 108,
288, 118,
472, 128,
651, 137,
826, 146,
988, 154,
1148, 162,

186, 265,
373, 274,
556, 283,
730, 292,
901, 300,
1063, 308,
1228, 319,

87, 412,
273, 420,
459, 429,
637, 435,
810, 443,
975, 447,
1142, 457,

167, 574,
363, 579,
541, 583,
722, 590,
885, 594,
1055, 601,
1215, 604
};

int DDDMANIA=0;
int DISPLAY=1;
int WORK=2;

int dx=-5,dy;
int prllx=10;


void drawL(int xx,   int yy, int r, int line, int pos)
{
//ESP_CircleFill(xx,yy,r,0xff0000,0x00ff00);
//
//x=pt[line*7+pos][0],y=pt[line*7+pos][1]
//
int px,py;
int col;

px=pt[line*7+pos][0]+dx;
py=pt[line*7+pos][1]+dy;
for (int y=-r;y<r;y++){
	for (int x=-r;x<r;x++){
		ESP_Select(DDDMANIA);
//		col=ESP_Point(px+x,py+y);
		col=ESP_Point(px+(-x),py+(-y));
		ESP_Select(DISPLAY);
		ESP_Pset(xx+x,yy+y,col);


	}
}
}
void drawR(int xx,   int yy, int r, int line, int pos)
{
//ESP_CircleFill(xx,yy,r,0xff0000,0x00ff00);
//
//x=pt[line*7+pos][0],y=pt[line*7+pos][1]
//
int px,py;
int col;

px=pt[line*7+pos][0]+dx+prllx;
py=pt[line*7+pos][1]+dy;
for (int y=-r;y<r;y++){
	for (int x=-r;x<r;x++){
		ESP_Select(DDDMANIA);
//		col=ESP_Point(px+x,py+y);
		col=ESP_Point(px+(-x),py+(-y));
		ESP_Select(DISPLAY);
		ESP_Pset(xx+x,yy+y,col);


	}
}
}



void draw0(int x0,int y0,int dist,int r)
{
int xr,yr;
int xt,yt;
xr=int(cos(DEG2RAD(60))*dist+0.5);
yr=int(sin(DEG2RAD(60))*dist+0.5);

xt=x0+dist*7+10;
yt=y0;
//x0=xx;y0=yy;
for (int i=0; i<7;i++) drawL(x0+dist*i, y0, r, 0, i);
x0+=xr;y0+=yr;
for (int i=0; i<7;i++) drawL(x0+dist*i, y0, r, 1, i);
x0-=xr;y0+=yr;
for (int i=0; i<7;i++) drawL(x0+dist*i, y0, r, 2, i);
x0+=xr;y0+=yr;
for (int i=0; i<7;i++) drawL(x0+dist*i, y0, r, 3, i);

x0=xt;y0=yt;
for (int i=0; i<7;i++) drawR(x0+dist*i, y0, r, 0, i);
x0+=xr;y0+=yr;
for (int i=0; i<7;i++) drawR(x0+dist*i, y0, r, 1, i);
x0-=xr;y0+=yr;
for (int i=0; i<7;i++) drawR(x0+dist*i, y0, r, 2, i);
x0+=xr;y0+=yr;
for (int i=0; i<7;i++) drawR(x0+dist*i, y0, r, 3, i);

}


void ESP_Ready(void)
{
//        ESP_CreateImage(DISPLAY,"work",0,200,1280,720,100);
        ESP_OpenTextWindow(0,0,0,152,150);
        ESP_SetForeground(ESPMAINWINDOW);
 
		
#define BUTTON_MAX 10
	ESP_OpenButtonBox(200,0,2,BUTTON_MAX/2);

	ESP_SetButtonBoxTitle(0,"dist-");
	ESP_SetButtonBoxTitle(1,"dist+");
	ESP_SetButtonBoxTitle(2,"r-");
	ESP_SetButtonBoxTitle(3,"r+");
	ESP_SetButtonBoxTitle(4,"");
	ESP_SetButtonBoxTitle(5,"");
	ESP_SetButtonBoxTitle(6,"");
	ESP_SetButtonBoxTitle(7,"");
	ESP_SetButtonBoxTitle(8,"<<");
	ESP_SetButtonBoxTitle(9,">>");

	ESP_MOUSE=1;


	

//		for (int i=0;i<28;i++)
//			ESP_Printf("%d, %d\n",pt[0][i],pt[1][i]);//bad
//			ESP_Printf("%d, %d\n",pt[i][0],pt[i][1]);//good
		
		ESP_Printf("dddmaniãtCAC摜hbOStartNbN.\n");
}

void ESP_Main(void)
{

int xx=50,yy=50;
int dist,r;
//int x0,y0;
//int xr,yr;
int tMX=-1,tMY=-1;


	if (ESP_GetDisplayMode(0)) {
        ESP_CreateImage(DISPLAY,"display",0,200,1280,720,100);
dist=20;
r=dist/2;

ESP_ClearTextWindow();
ESP_Printf("dist: %d r: %d\n",dist,r);
ESP_Printf("dx: %d dy: %d\n",dx,dy);
ESP_Printf("prllx: %d\n",prllx);

draw0(xx,yy,dist,r);

ESP_Update();


	while(1){
			for (int b=0; b<BUTTON_MAX; b++){
					ESP_Printf("");//ȂƑs\BȂŁH

				if(ESP_GetButtonBox(b)){
				switch(b){
					case 0:
						dist -= 1;
						if (dist<1) dist=1;
						break;
					case 1:
						dist += 1;
						break;
					case 2:
						r -= 1;
						if (r<1) r=1;
						break;
					case 3:
						r += 1;
						break;
					case 4:
						dx -= 1;
						break;
					case 5:
						dx += 1;
						break;
					case 6:
						dy -= 1;
						break;
					case 7:
						dy += 1;
						break;
					case 8:
						prllx -= 1;
						break;
					case 9:
						prllx += 1;
						break;
				}
				}
				ESP_BoxFill(DISPLAY, 0, 1280, 720, 0, 0);
				draw0(xx,yy,dist,r);
				ESP_Update_(DISPLAY);
ESP_ClearTextWindow();
ESP_Printf("dist: %d r: %d\n",dist,r);
ESP_Printf("dx: %d dy: %d\n",dx,dy);
ESP_Printf("prllx: %d\n",prllx);
				
			}


			//			if ((ESP_MW == DISPLAY)&&(ESP_ML)){
			if (ESP_ML){
				if (tMX!=-1){
					if (tMX!=ESP_MX){
						dx+=(ESP_MX-tMX)/10;
						tMX=ESP_MX;
						ESP_BoxFill(DISPLAY, 0, 1280, 720, 0, 0);
						draw0(xx,yy,dist,r);
						ESP_Update_(DISPLAY);
						ESP_ClearTextWindow();
						ESP_Printf("dist: %d r: %d\n",dist,r);
						ESP_Printf("dx: %d dy: %d\n",dx,dy);
						ESP_Printf("prllx: %d\n",prllx);
					}
				} else tMX=ESP_MX;
				if (tMY!=-1){
					if (tMY!=ESP_MY){
						dy+=(ESP_MY-tMY)/10;
						tMY=ESP_MY;
						ESP_BoxFill(DISPLAY, 0, 1280, 720, 0, 0);
						draw0(xx,yy,dist,r);
						ESP_Update_(DISPLAY);
						ESP_ClearTextWindow();
						ESP_Printf("dist: %d r: %d\n",dist,r);
						ESP_Printf("dx: %d dy: %d\n",dx,dy);
						ESP_Printf("prllx: %d\n",prllx);
					}
				} else tMY=ESP_MY;

			}else{
				tMX=-1;
				tMY=-1;
			}
			ESP_Sleep(50);
	}
			

		} else {
		ESP_Pause("dddmaniãtCAC摜hbOĉ");
	}

}//main

void ESP_Finish(void)
{
}
